/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2005, 2008 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
/*
 * Initialize the quick search box by marking every field as display none and 
 * then displaying the last searched field
 */
function initQuickSearch(activeParamIndex)
{
    for (i = 0; i < params.length; i++)
    {
        hideID(params[i] + '_qsdiv');
    }
    if (params.length > 0)
    {
        showID(params[activeParamIndex] + '_qsdiv');
    }
}
/**
 * Quick Search swap
 */
function swapQuickSearch()
{
    var elem = getElement('SearchParams');
    if (elem == null)
    {
        return;
    } 
    var index =  elem.selectedIndex;
    for (i = 0; i < params.length; i++)
    {
        hideID(params[i] + '_qsdiv');
    }
    if (params.length > 0)
    {
        showID(params[index] + '_qsdiv');
    }    
}
/**
 * Search Function for quick search.
 * 1. Identify the search parameter to search on
 * 2. Identify the id to submit for that search selection
 * 3. Feed that to the Search Field Value
 * 4. Submit
 */
function quickSearch(idToSubmit, idValueToSubmit)
{
    //Retrieve the param we are searching on
    var elem = getElement('SearchParams');
    if (elem == null)
    {
        return;
    } 
    var index =  elem.selectedIndex;
    if (index != -1)
    {
        var paramName = elem.value;
        var childIdToSubmit = mapSearchParamXChildIdToSubmit[paramName];
        var field = getElement(childIdToSubmit);
        if (field)
        {
            var searchValue = trim(field.value);
            if (searchValue && searchValue.length != 0)
            {
                var validator = validators[paramName];
                if (validator)
                {
                    try
                    {
                        eval(validator);
                    }
                    catch(e)
                    {
                        //validator does not exist
                        return;
                    }    
                    var result = eval(validator + "(\'" + searchValue + "\');");
                    if (result == false)
                    {
                        var validationMessage = validationMessages[paramName];
                        if (validationMessage)
                        {
                            alert(validationMessage);
                        }
                        return;
                    }
                }
            }
            var idValueToSubmit = getElement(idValueToSubmit);
            if (idValueToSubmit)
            {
                idValueToSubmit.value = searchValue;
            }            
        }
        var idToSubmit = getElement(idToSubmit);
        if (idToSubmit)
        {
            idToSubmit.value = paramName;
        }    
        document.QuickSearchForm.submit();        
    }
}
