// Morten's JavaScript Tree Menu
// version 2.3.0, dated 2001-04-30
// http://www.treemenu.com/

// Copyright (c) 2001, Morten Wang & contributors
// All rights reserved.

// This software is released under the BSD License which should accompany
// it in the file "COPYING".  If you do not have this file you can access
// the license through the WWW at http://www.treemenu.com/license.txt
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE

/******************************************************************************
* User-configurable options.                                                  *
******************************************************************************/
// Menu table width, either a pixel-value (number) or a percentage value.
var MTMTableWidth = "100%";

// variable for determining whether a sub-menu always gets a plus-sign
// regardless of whether it holds another sub-menu or not
var MTMSubsGetPlus = "Submenu";

// variable that defines whether the menu emulates the behaviour of
// Windows Explorer
var MTMEmulateWE = true;

// Directory of menu images/icons
var MTMenuImageDirectory = "../images/";

// Variables for controlling colors in the menu document.
// Regular BODY atttributes as in HTML documents.
//var MTMBGColor = "#000033";
var MTMBGColor = "#F5F5F5";
//var MTMBackground = "blueback.jpg";
var MTMBackground = "";
var MTMTextColor = "black";

// color for all menu items
var MTMLinkColor = "blue";

// Hover color, when the mouse is over a menu link
var MTMAhoverColor = "red";

// Foreground color for the tracking & clicked submenu item
var MTMTrackColor ="blue";
var CMGTTrackBkColor = "#CCCCCC";
var MTMSubExpandColor = "blue";
var MTMSubClosedColor = "blue";

// All options regarding the root text and it's icon
var MTMRootIcon = "modelgroup.gif";
var MTMenuText = "";
var MTMRootColor = "darkblue";
var MTMRootFont = "Arial, Helvetica, sans-serif";
var MTMRootCSSize = "84%";
var MTMRootFontSize = "-1";

// Font for menu items.
var MTMenuFont = "Arial, Helvetica, sans-serif";
var MTMenuCSSize = "84%";
var MTMenuFontSize = "-1";

// Variables for style sheet usage
// 'true' means use a linked style sheet.
var MTMLinkedSS = false;
var MTMSSHREF = "style/menu.css";

// Additional style sheet properties if you're not using a linked style sheet.
// See the documentation for details on IDs, classes & elements used in the menu.
// Empty string if not used.
var MTMExtraCSS = "";

// Header & footer, these are plain HTML.
// Leave them to be "" if you're not using them

var MTMHeader = "";
var MTMFooter = "";

// Whether you want an open sub-menu to close automagically
// when another sub-menu is opened.  'true' means auto-close
var MTMSubsAutoClose = false;

// Cookie usage.  First is use cookie (yes/no, true/false).
// Second is cookie name to use.
// Third is how many days we want the cookie to be stored.

var MTMUseCookies = false;
var MTMCookieName = "MTMCookie";
var MTMCookieDays = 3;

// Tool tips.  A true/false-value defining whether the support
// for tool tips should exist or not.
var MTMUseToolTips = true;

/******************************************************************************
* User-configurable list of icons.                                            *
******************************************************************************/
var MTMIconList = null;
MTMIconList = new IconList();
//MTMIconList.addIcon(new MTMIcon("menu_link_external.gif", "http://", "pre"));
//MTMIconList.addIcon(new MTMIcon("menu_link_pdf.gif", ".pdf", "post"));

var icon_MG = "modelgroup.gif";
var icon_Mod = "icnModel.gif";
var icon_OCSA = "icnOCSA.gif";
var icon_OISA = "icnOISA.gif";
var icon_ModRoot = "icnModel.gif";
var icon_OCSARoot = "icnOCSA.gif";
var icon_OISARoot = "icnOISA.gif";
var icon_Subassembly = "icnModel.gif";
var icon_ModelSubassemblyReference = "icnModel.gif";
var icon_OCSAReference = "icnOCSA.gif";
var icon_OISAReference = "icnOISA.gif";
var icon_OC = "icnOptionClass.gif";
var icon_OI = "icnOptionItem.gif";

// END NON-TRANSLATABLE
