/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2002, 2006 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE

function TableView( bool_lineItemsHaveDeletion )
{
	// table view properties
	this.bool_lineItemsHaveDeletion = bool_lineItemsHaveDeletion;
	this.str_tableDef;
	this.str_cellDef;
	this.str_columnSeperator;
	this.int_colSpan;
	this.str_spanId;
	this.str_dividerClass;
	this.int_numEntries = 0;
	this.str_tableHeaderDef;
	this.str_validateProductText;
	this.formName;	
	this.bool_allowNonValidProducts = false;
	
	// Array of LineItem objects
	this.OA_lineItems = new Array();
}
TableView.prototype.deleteFromList = deleteFromList;
TableView.prototype.addToList = addToList;
TableView.prototype.addSKUs = addSKUs;
TableView.prototype.addNonValidSKUs = addNonValidSKUs;
TableView.prototype.getCommonValuesList = getCommonValuesList;
TableView.prototype.getAlternateValuesList = getAlternateValuesList;
TableView.prototype.toggleProductEntry = toggleProductEntry;
TableView.prototype.nonValidProductUpdate = nonValidProductUpdate;


function addSKUs( sku, qty, reason)
{
    this.OA_lineItems[this.OA_lineItems.length] = new LineItem();
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[0] = encodeJS(sku);
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[1] = qty;
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[2] = reason;
    this.OA_lineItems[this.OA_lineItems.length-1].bool_hasDeletion = ( this.bool_lineItemsHaveDeletion ) ? true : false;
    this.OA_lineItems[this.OA_lineItems.length-1].verify_Product = true;
    this.int_numEntries++;
}

function addNonValidSKUs( sku, name, desc, qty, price, reason)
{
    this.OA_lineItems[this.OA_lineItems.length] = new LineItem();
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[0] = encodeJS(sku);
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[1] = qty;
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[2] = reason;
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[3] = encodeJS(name);
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[4] = encodeJS(desc);    
    this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[5] = price;    
    this.OA_lineItems[this.OA_lineItems.length-1].bool_hasDeletion = ( this.bool_lineItemsHaveDeletion ) ? true : false;
    this.OA_lineItems[this.OA_lineItems.length-1].verify_Product = false;
    this.int_numEntries++;
}

function encodeJS( text) 
{
    if (text == null)
        return null;
        
    var buffer = "";

    for (var i=0; i < text.length; i++)
    {
        var ch = text.charAt(i);
        switch(ch)
        {
            case '<':
                buffer += "&lt;";
                break;
            case '>':
                buffer += "&gt;";                
                break;
            default:
                buffer += ch;
                break;
        }    
    }
    return buffer;
}  

function decodeJS( text)
{
    text = text.replace( "&lt;", "<");
    text = text.replace( "&gt;", ">");
    return text;
}

function addToList( OA_frmElements )
{       
	this.OA_lineItems[this.OA_lineItems.length] = new LineItem();
	for( var i = 0; i < OA_frmElements.length; i++ )
	{
		this.OA_lineItems[this.OA_lineItems.length-1].AA_propertyArray[i] = encodeJS(OA_frmElements[i].value);
		this.OA_lineItems[this.OA_lineItems.length-1].bool_hasDeletion = ( this.bool_lineItemsHaveDeletion ) ? true : false;
		this.OA_lineItems[this.OA_lineItems.length-1].verify_Product = true;
	}	
	this.int_numEntries++;
}

// Function sets the specified index to null which will be ignored during 
// paint time and request assignment.
function deleteFromList( int_index )
{    
	this.OA_lineItems.setIndexToNull( int_index );
	this.int_numEntries--;	
}

function toggleProductEntry(int_index)
{    
    var verify = !this.OA_lineItems[int_index].verify_Product;
    this.OA_lineItems[int_index].verify_Product = verify;
    
    if(!this.OA_lineItems[int_index].verify_Product)
    {
        this.OA_lineItems[int_index].AA_propertyArray[3] = ("N/A");
        this.OA_lineItems[int_index].AA_propertyArray[4] = ("N/A");                
        this.OA_lineItems[int_index].AA_propertyArray[5] = ("0");                       
    }
    else
    {
        this.OA_lineItems[int_index].AA_propertyArray[3] = null;
        this.OA_lineItems[int_index].AA_propertyArray[4] = null;
        this.OA_lineItems[int_index].AA_propertyArray[5] = null;
    }
}

function nonValidProductUpdate(int_index)
{
    var name = eval(this.formName + ".productName" + int_index).value;
    if (trim(name) == "")
    {
        name="N/A"
        eval(this.formName + ".productName" + int_index).value = name
    }
    this.OA_lineItems[int_index].AA_propertyArray[3] = name;
    var desc = eval(this.formName + ".productDesc"+int_index).value;
    if (trim(desc) == "")
    {
        desc="N/A"
        eval(this.formName + ".productDesc"+int_index).value = desc;
    }
    this.OA_lineItems[int_index].AA_propertyArray[4] = desc;
    var price = eval(this.formName + ".productPrice"+int_index).value;
    this.OA_lineItems[int_index].AA_propertyArray[5] = price;
    floatValue=parseFloat(price) 
    if (isNaN(floatValue))
	{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
	    var msg1 = "Please enter valid price.";	        
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        alert(msg1);
	    return;
	}
}

// Returns a string of the values in the TableView.OA_lineItems.AA_propertyArray.
// The arg 'int_index' specifies which index to grab the value from when traversing
// the OA_lineItems.AA_propertyArray.
// The delimeter specifies how the values are seperated in the string:
// val<char_delimeter>val<char_delimeter>val<char_delimeter>val
function getCommonValuesList( int_index, char_delimeter )
{
	var str_commonVals = "";
	for( var i = 0, j = 0; i < this.OA_lineItems.length; i++ )
	{
		if( this.OA_lineItems[i] != null )
		{
			str_commonVals += this.OA_lineItems[i].AA_propertyArray[int_index];
			str_commonVals += ( j < this.int_numEntries-1 ) ? char_delimeter : '';
			j++;
		}
	}
	return str_commonVals;
}


function getAlternateValuesList( A_keyStrings, char_delimeter )
{
	var str_commonVals = "";
	for( var i = 0; i < this.OA_lineItems.length; i++ )
	{
		if( this.OA_lineItems[i] != null )
		{
			for( var j = 0; j < this.OA_lineItems[i].AA_propertyArray.length; j++ )
			{
				str_commonVals += ( A_keyStrings[j] + this.OA_lineItems[i].AA_propertyArray[j] );
				str_commonVals += ( i < this.int_numEntries ) ? char_delimeter : '';
			}
		}
	}
	return str_commonVals;
}
/************************* TableView Object ********************************/

/************************* LineItem Object ********************************/
function LineItem( bool_hasDeletion )
{
	this.bool_hasDeletion = bool_hasDeletion;
	this.verify_Product = true;
	
	// Array of data properties representing the column data
	this.AA_propertyArray = new Array();  
}

/************************* LineItem Object ********************************/

/************************* Global functions ********************************/
function registerDataInputFields( OA_frmElements, R_eventFunction ) 
{
  for( var i = 0; i < OA_formElements.length; i++ )
  {
      	OA_frmElements[i].onkeydown = function(e) {
    	if( str_browser == "ie" )
    	{
    		e = window.event;    		
        	if( e.keyCode-0 == 13 )
        	{
				// updateUserList( OA_frmElements, O_tableView );			    
				eval( R_eventFunction );
			}
			e.cancelBubble = true;
    	}
   		else if( str_browser == "nn" )
    	{
      		if( ( e.which-0 ) == 13 )
        	{
				// Will launch a seperate window
				eval( R_eventFunction );
			} 
    	}
  	} // end function def
  }// end for loop
}


/************************* Global functions ********************************/
// END NON-TRANSLATABLE
