/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2005, 2007 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
function getElement(id)
{
	if (document.all)
	{
	    return document.all(id);
	}
	else
    if (document.getElementById)
    {
	    return document.getElementById(id);
    }
}
function showID(id)
{
	var elem = getElement(id);
	if (elem)
	{
		elem.style.visibility = 'visible';
        elem.style.display = 'inline';        
	}
}
function showIDBlock(id)
{
	var elem = getElement(id);
	if (elem)
	{
		elem.style.visibility = 'visible';
        elem.style.display = 'block';        
	}
}
function hideID(id)
{
	var elem = getElement(id);
	if (elem)
	{
		elem.style.visibility = 'hidden';
        elem.style.display = 'none';        
	}
}        
function reset(fieldId, resetValue)
{
    var field = getElement(fieldId);
    if (field)
    {
        field.value = resetValue;
    }
}
function validatePositiveInt(str)
{
    var i = parseInt( str);
    if (i < 0)
    {
        return false;
    }
    return (("" + parseInt(str)) == str);
}


function extractDateFromDateFieldId(fieldId, fieldName, format, dateIsRequired, displayAlert) 
{
    // defaults for optional args
    if (arguments.length <= 3) 
    {
        dateIsRequired = false;
        displayAlert = true;
    }
    // Form must follow these naming conventions:
    //   Common name for form = <dateForm>
    //   Date text field = <dateForm> + "DateField"
    //   Year value = <dateForm> + "Year"
    //   Month value = <dateForm> + "Month"
    //   Date value = <dateForm> + "Date"
    var elem = document.getElementById(fieldId);                    
    if(dateIsRequired || (elem && dateTrim(elem.value).length>0)) 
    {
        var dateText = dateTrim(elem.value);        
        if (isDate(dateText,format)) 
        {
            var theDate = getDateFromFormat(dateText,format);            
            var yearForm = document.getElementById(fieldId + 'Year');
            var monthForm = document.getElementById(fieldId + 'Month');
            var dateForm = document.getElementById(fieldId + 'Date');
            yearForm.value  = theDate.getFullYear();
            monthForm.value = theDate.getMonth();
            dateForm.value  = theDate.getDate();            
            return theDate;
        }
        else 
        if (displayAlert) 
        {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
            var msg=fieldName +
                " is invalid: Please enter a valid date in " +
                format +
                " format\nor select the date from a calendar by clicking the Calendar button.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
            alert(msg);
            return false;
        }
    }
    // date field is required and date field is empty, then display error message
    else 
    if (dateIsRequired && displayAlert) 
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg = fieldName +
            " is required: Please enter a valid date in " +
            format +
            " format\nor select the date from a calendar by clicking the Calendar button.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        alert(msg);
        return false;
    }
    // date is not required and date field is empty, so return true
    else
    {
        return true;
    }
}
function verifyDate(id, dateFormat, verboseNameForField)
{
    var theDate;
    var flag = true;
    var starttime;
    var endtime;
    var elem = getElement(id);
    if (elem == null)
    {
        return false;
    }
    elem.value = trim(elem.value);
    // Create Date Start
    if ( elem.value !=  "")
    {
        theDate = extractDateFromDateFieldId(
                                id,
                                verboseNameForField,
                                dateFormat,
                                false,
                                true);
        if (theDate == false)
        {
            return false;
        }
    }
    else
    {
        flag = false;
    }            
    return true;
}
    
    

function textCounter(id, maxlength, errorMessage) 
{
	var elem = getElement(id);
	if (elem != null)
	{
		if (elem.value.length > maxlength) // if too long...trim it!
		{
		    alert(errorMessage);
	        elem.value = elem.value.substring(0, maxlength);
	    }
	}
}

function isLeapYear(year) 
{
	return ((year%4 == 0) && ((year%100 != 0) ||  (year%400 == 0))); 
}
var NUM_DAYS_MONTH = new Array("31","28","31","30","31","30","31","31","30","31","30","31");
var NUM_DAYS_LEAPMONTH = new Array("31","29","31","30","31","30","31","31","30","31","30","31");


function getIsCreditCardExpired(expMonth, expYear)
{
	if (!isEmpty('' + expMonth) && !isEmpty(expYear)) 
	{
		var daysInMonth = "";
		if(isLeapYear(expYear))
		{
			daysInMonth = NUM_DAYS_LEAPMONTH[expMonth];			
		}
		else
		{
			daysInMonth = NUM_DAYS_MONTH[expMonth];
		}		
		var inputDate = new Date(expYear, expMonth, daysInMonth, 23, 59, 59);		
        if (isPast(inputDate)) 
        {
        	return true;
		}
	}
	return false;
}

/* Toggle widgets on and off */
function toggleCartWidget(id)
{
    var o = el(id);
    var expanded = o.expanded;
    if (expanded == 0)
    {
        o.expanded = 1;
        showIDBlock(id + 'Body');
        showID(id + 'Up');
        hideID(id + 'Dn');
    }
    else
    if (typeof expanded == 'undefined' || expanded == 1)
    {
        o.expanded = 0;
        hideID(id + 'Body');
        hideID(id + 'Up');
        showID(id + 'Dn');
    }
}

function el(id)
{
    return document.getElementById(id);
}

//The function gives the alert 'alertToPopUp' if the specified date(year,month,date) is more than daysToCompare  from the current date.
function checkDateLessThan(dateSpecified,daysToCompare)
{
	var curDate = new Date();
	var futdate = new Date();
	var expdate = futdate.getTime();
	expdate += 3600*1000*24*daysToCompare; //expires in 1 hour(milliseconds) 
	futdate.setTime(expdate);
	if(dateSpecified>futdate)
	{
		return true;
	}
return false;
}
// END NON-TRANSLATABLE
