/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2002, 2005 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
var CRON_TYPE_APPL = 1;

function processSave()
{
    var cronKey = trim(document.CronJobDetailDisplayForm.CronName.value);
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_emptyCronName = "Cron name should not be empty";
    var msg_emptyProgramName = "Program name should not be empty";
    var msg_emptyUserName = "Username should not be empty for an application cron";
    var msg_emptyPassword = "Password should not be empty for an application cron";
    var msg_startDateAfterEndDate = "The start date specified is greater than the end date";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
	if (cronKey == "")
	{
		alert(emptyCronName);
		document.CronJobDetailDisplayForm.CronName.focus();
		return;
	}
	//check for unique cron job name
	if (document.CronJobDetailDisplayForm.Operation.value != "Update")
	{
		var aCronJobNames = this.parent.getCronJobNames();
		if(isCronNameUnique(aCronJobNames, cronKey) == false)
		{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
	        var temp = "Job Name \"" + cronKey
                    + "\" already exist. Please enter a unique Cron Job name.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
			alert(temp);
			document.CronJobDetailDisplayForm.CronName.focus();
			return;
		}
	}
	
	if(document.CronJobDetailDisplayForm.ImplClass.value == "")
	{
		alert(msg_emptyProgramName);
		document.CronJobDetailDisplayForm.ImplClass.focus();
		return;
	}
	
	//If selected cron type is application then enforce the username and password value
	if(document.CronJobDetailDisplayForm.CronType[CRON_TYPE_APPL].checked == true)
	{
		if(document.CronJobDetailDisplayForm.Username.value == "")
		{
			alert(msg_emptyUserName);
			document.CronJobDetailDisplayForm.Username.focus();
			return;
		}
		if(document.CronJobDetailDisplayForm.Password.value == "")
		{
			alert(msg_emptyPassword);
			document.CronJobDetailDisplayForm.Password.focus();
			return;
		}
	}
	
	if(startGreaterThanEndTime(this.document.CronJobDetailDisplayForm.StartDate, 
									this.document.CronJobDetailDisplayForm.StartMonth,
									this.document.CronJobDetailDisplayForm.StartYear,
									this.document.CronJobDetailDisplayForm.StartHours,
									this.document.CronJobDetailDisplayForm.StartMinutes,
									this.document.CronJobDetailDisplayForm.EndDate,
									this.document.CronJobDetailDisplayForm.EndMonth,
									this.document.CronJobDetailDisplayForm.EndYear,
									this.document.CronJobDetailDisplayForm.EndHours,
									this.document.CronJobDetailDisplayForm.EndMinutes))
	{
		alert(msg_startDateAfterEndDate);
		document.CronJobDetailDisplayForm.StartDate.focus();
		return;
	}
	
    var msg_requirePosFrequency = "Please enter a positive number for Frequency Value!";
    var msg_requireNonzeroFrequency = "Please enter a value greater than \"0\" for Frequency Value!";
    var msg_requireNonemptyFrequency = "Frequency Value should not be empty";
    var msg_requireNumericFrequency = "Please enter a number for Frequency Value";
	if(document.CronJobDetailDisplayForm.FrequencyValue.value < 0)
	{
		alert(msg_requirePosFrequency);
		document.CronJobDetailDisplayForm.FrequencyValue.focus();
		return;
	}
	if(document.CronJobDetailDisplayForm.FrequencyValue.value == 0)
	{
		alert(msg_requireNonzeroFrequency);
		document.CronJobDetailDisplayForm.FrequencyValue.focus();
		return;
	}
	if(document.CronJobDetailDisplayForm.FrequencyValue.value == "")
	{
		alert(msg_requireNonemptyFrequency);
		document.CronJobDetailDisplayForm.FrequencyValue.focus();
		return;
	}
	
	if(validateInteger(document.CronJobDetailDisplayForm.FrequencyValue.value) == false)
	{
		alert(msg_requireNumericFrequency);
		document.CronJobDetailDisplayForm.FrequencyValue.focus();
		return;
	}

	this.parent.Dispatch("GoToCronSchedulerHomePage","Save","");
	this.document.CronJobDetailDisplayForm.submit();

}

function isCronNameUnique(aCronJobNames, cronName)
{
	for(var i=0; i<aCronJobNames.length; i++)
	{
		if(aCronJobNames[i] == cronName)
		{
			return false;
		}
	}
	return true;
}

function cancel()
{
	this.parent.Dispatch("GoToCronSchedulerHomePage","Cancel","");
}

function onCronTypeRadioButtonChange()
{
	var flag = true;
	if(document.CronJobDetailDisplayForm.CronType[CRON_TYPE_APPL].checked == true)
	{
		//Enable Username and Password fields
		flag = false;
	}
	document.CronJobDetailDisplayForm.Username.disabled = flag;
	document.CronJobDetailDisplayForm.Password.disabled = flag;
}
// END NON-TRANSLATABLE
