/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2002, 2002 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
// If the methods are built into the array object use them, otherwise use these instead
var test = new Array;
if ( !test.splice ) 
{
    Array.prototype.splice = splice;
}
if ( !test.pop ) 
{
    Array.prototype.pop = pop;
}
if ( !test.push )
{
    Array.prototype.push = push;
}
if ( !test.unshift ) 
{
    Array.prototype.unshift = unshift;
}
if ( !test.shift ) 
{
    Array.prototype.shift =shift ;
}

// Array extension
function splice () 
{
    var index = arguments[0];
    var num = arguments[1];
    var arg = new Array;
    var tmpArray1 = new Array;
    var tmpArray2 = new Array;
    var i;
    var cnt1 = 0;
    var cnt2 = 0;
    
    // Get the arguments list.
    for (i = 2; i < arguments.length; i++) 
    { 
        arg[i - 2] = arguments[i];
    }
    
    // Loop through the array abject
    for (i = 0; i < this.length; i++) 
    {    
        // Put the new elements in the proper place
        if (i == index) 
        { 
            tmpArray2 = tmpArray2.concat (arg);
            cnt2 += arg.length; 
        }
        
        // Take out specified elements
        if ((i >= index) && (i < (index + num)) && (num > 0)) 
        {
            tmpArray1[cnt1++] = this[i]; 
        }    
        // Make temp array out of the rest
        else 
        {
            tmpArray2[cnt2++] = this[i]; 
        }
    }
    
    // Rebuild the array object
    this.length = tmpArray2.length;
    for (i = 0; i < tmpArray2.length; i++) 
    {
        this[i] = tmpArray2[i];
    }    
    //Return the removed elements as an array if there is more than one
    return tmpArray1.length > 0 ? tmpArray1.length == 1 ? tmpArray1[0] : tmpArray1 : 'undefined';
}

function pop () 
{
     // Get the poped element
     var poped = this[this.length - 1];
     // Deincriment array
     this.length--;
     // Return poped element
     return poped;
}

function shift () 
{
    // Get the shifted element
    var shifted = this[0], i;    
    // Rebuild array
    for (i = 0; i < this.length; i++) 
    {
        this[i] = this[i + 1];
    }
    this.length--;    
    // Return shifted element
    return shifted;
}

function unshift () 
{
    var tmpArray1 = new Array, tmpArray2 = new Array, i;
    var cnt = 0;
    
    // Build a temp array from what was passed in
    for (i = 0; i < arguments.length; i++) 
    { 
        tmpArray1[cnt++] =arguments[i];
    }
    
    // Put the temp array at the beginning of array object
    tmpArray2 = tmpArray1.concat(this);
    
    // Rebuild array object
    for (i = 0; i < tmpArray2.length; i++) 
    {
        this[i] = tmpArray2[i];
    }    
    // Return the new array
    return this;
}

function push () 
{
    var tmpArray1 = new Array, tmpArray2 = new Array, i;
    var cnt = 0;
    
    // Build temp array with new elements at the end
    for (i = 0; i < arguments.length; i++) 
    {
        tmpArray1[cnt++] = arguments[i];
    }
    
    // Put the temp array at the end of array object
    tmpArray2 = this.concat(tmpArray1);
    
    // Rebuild array object
    for (i = 0; i < tmpArray2.length; i++) 
    {
        this[i] = tmpArray2[i];
    }    
    // Return the new array
    return this;
}

// END NON-TRANSLATABLE

