/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2005, 2005 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
    function addToListBox(comboBox, listBox)
    {
        i = comboBox.selectedIndex;
        if ( i==-1 || i==0)
            return;

        // see if it is already in the list
        for (j=0;j<listBox.options.length; j++)
        {
	        if ( listBox.options[j].value == comboBox.options[i].value)
	        return;	// already got it
        }

        // else add the selected item to the DistiList
        j = listBox.options.length;
        listBox.options[j] = new Option(comboBox.options[i].text,
				        comboBox[i].value, false, false);
    }


    function categoryChangeHandler(e)
    {
        var comboBox = document.PartnerForm.PartnerProductCategoryList_Source;
        var listBox = document.PartnerForm.PartnerProductCategoryList_PartnerProductCategory_ProductCategoryName;
        addToListBox(comboBox, listBox);
    }

    function territoryChangeHandler(e)
    {
        var comboBox = document.PartnerForm.PartnerTerritoryList_Source;
        var listBox = document.PartnerForm.PartnerTerritoryList_PartnerTerritory_TerritoryName;
        addToListBox(comboBox, listBox);
    }


    function verticalChangeHandler(e)
    {
        var comboBox = document.PartnerForm.ApprovedPartnerVerticalList_Source;
        var listBox = document.PartnerForm.PartnerVerticalList_PartnerVertical_Market;
        addToListBox(comboBox, listBox);
    }


    function deleteItem(listBox)
    {
        var index = listBox.selectedIndex
        var length = listBox.length
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_requireEntry = "Select an entry in the listbox.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE

        if ( index != -1)
	    {
		for(var i=0;i<length;++i)
		{
  		    index = listBox.selectedIndex;
		    if(index != -1)
		      listBox.options[index] = null;
		}
	    }
	    else
	        alert(msg_requireEntry);
    }

    function removeSpacerFromList(listBox)
    {
        if ( listBox.options.length > 0 )
	    {
	        if ( listBox.options[0].text == "------------------------" )
		    listBox.options[0] = null;
	    }
    }

    function initPage(f)
    {
        if ( f.PartnerProductCategoryList_Source)
        {
            f.PartnerProductCategoryList_Source.onchange = categoryChangeHandler;
        }
        if ( f.PartnerTerritoryList_Source)
        {
            f.PartnerTerritoryList_Source.onchange = territoryChangeHandler;
        }
        if ( f.ApprovedPartnerVerticalList_Source)
        {
            f.ApprovedPartnerVerticalList_Source.onchange = verticalChangeHandler;
        }
        var listBox;
        if ( f.PartnerProductCategoryList_PartnerProductCategory_ProductCategoryName)
        {
            listBox = f.PartnerProductCategoryList_PartnerProductCategory_ProductCategoryName;
            removeSpacerFromList(listBox);
        }
        if ( f.PartnerTerritoryList_PartnerTerritory_TerritoryName)
        {
            listBox = f.PartnerTerritoryList_PartnerTerritory_TerritoryName;
            removeSpacerFromList(listBox);
        }
        if ( f.PartnerVerticalList_PartnerVertical_Market)
        {
            listBox = f.PartnerVerticalList_PartnerVertical_Market;
            removeSpacerFromList(listBox);
        }
    }


    function buildListValues(listBox, hiddenList)
    {
        i = listBox.options.length;
        var list = "";
        var first = true;

        for( j = 0;j < i; j++)
    	{
	        if ( !first )
		        list = list + "," + listBox.options[j].value;
	        else
		    {
		        first = false;
		        list = listBox.options[j].value;
		    }
	        listBox.options[j].selected=false;
	    }
        hiddenList.value=list;
    }

    function setRealListValues()
    {
        var listBox = document.PartnerForm.PartnerProductCategoryList_PartnerProductCategory_ProductCategoryName;
        var hiddenList = document.PartnerForm.Real__CategoryList;
        buildListValues(listBox, hiddenList);
        listBox = document.PartnerForm.PartnerTerritoryList_PartnerTerritory_TerritoryName;
        hiddenList = document.PartnerForm.Real__TerritoryList;
        buildListValues(listBox, hiddenList);
        listBox = document.PartnerForm.PartnerVerticalList_PartnerVertical_Market;
        hiddenList = document.PartnerForm.Real__ApprovedVerticalList;
        buildListValues(listBox, hiddenList);
    }

    function checkBusinessTabInput( )
    {

        var f = document.PartnerForm;
        if(f.ContractList_Contract_VolumeCommitmentYr != null)
		    if(checkInteger(f.ContractList_Contract_VolumeCommitmentYr.value, "Volume Commitment (YR)") == false)
		        return false;

	    if(f.ContractList_Contract_VolumeCommitmentQtrly != null)
		    if(checkInteger(f.ContractList_Contract_VolumeCommitmentQtrly.value, "Volume Commitment (QTR)") == false)
	    	    return false;
    }

    function checkContractsNotes()
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_noteLength = "Contracts Notes entry is too long.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        if ( document.PartnerForm.ContractList_Contract_Notes && !validateDescriptionLength(document.PartnerForm.ContractList_Contract_Notes.value) )
        {
            alert(msg_noteLength);
            return false;
        }
    }

    function validateMandatoryFields()
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_requireName = "Please enter Contract Name.";
        var msg_requireTypeCode = "Please enter Contract TypeCode.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        if ( document.PartnerForm.ContractList_Contract_Name)
        {
            if ( isNewlyNullOrTrimmedEmpty(document.OriginalFieldValues.ContractList_Contract_Name,
                                        document.PartnerForm.ContractList_Contract_Name) == true )
            {
                alert(msg_requireName);
                return false;
            }
        }
        if (document.PartnerForm.ContractList_Contract_TypeCode)
        {
            if ( isNewlyNullOrTrimmedEmpty(document.OriginalFieldValues.ContractList_Contract_TypeCode,
                                        document.PartnerForm.ContractList_Contract_TypeCode) == true )
            {
                alert(msg_requireTypeCode);
                return false;
            }
        }
    }

    function clickBusinessTab(primaryTab, secondaryTab, next, duplicateordelete)
    {
        if ((duplicateordelete != "Delete") &&
            (validateMandatoryFields() == false))
        {
            return;
        }
        if ( verifyDateFields() == false)
        {
            return;
        }

        if ( checkBusinessTabInput() == false)
        {
            return ;
        }

        if ( (duplicateordelete == null) || (duplicateordelete != "Delete") )
        {
            if ( checkContractsNotes() == false )
            {
	        return;
            }
        }

        if ( document.PartnerForm._Tab.value != primaryTab ||
	    document.PartnerForm._SubTab.value != secondaryTab )
    	    document.PartnerForm._CurrentIndex.value = "0";

        // user has selected the business tab, set the Tab value and submit the form
        document.PartnerForm._Tab.value = primaryTab;
        if ( secondaryTab != null )
	        document.PartnerForm._SubTab.value = secondaryTab;
        if (next != null )
	        document.PartnerForm._next.value = next;

        if ( duplicateordelete != null &&
	         duplicateordelete == "Delete" )
	        document.PartnerForm._Delete.value = "true";
        else if ( duplicateordelete != null &&
	        duplicateordelete == "Duplicate" )
	    document.PartnerForm._Duplicate.value = "true";
        setRealListValues();
        document.PartnerForm.submit();
    }
    
    function verifyDateFieldsWithDateFormat(dateFormat)
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
       var msg_agreementDate = "Contract Agreement Date";
       var msg_startDate = "Contract Start Date";
       var msg_endDate = "Contract End Date";
       var msg_startAfterEnd = "End Date cannot be before Start Date.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        if ( !document.PartnerForm.Agreement||
             !document.PartnerForm.StartDateActive ||
             !document.PartnerForm.EndDateActive)
        {
            return;
        }
        if (!verifyDate('Agreement', dateFormat, msg_agreementDate ))
        {
            return false;
        }
        if (!verifyDate('StartDateActive', dateFormat, msg_startDate ))
        {
            return false;
        }
        if (!verifyDate('EndDateActive', dateFormat, msg_endDate ))
        {
            return false;
        }
        
        var startday = document.PartnerForm.StartDateActiveDate.value;
        var startmonth = document.PartnerForm.StartDateActiveMonth.value;
        var startyear = document.PartnerForm.StartDateActiveYear.value;
        var endday = document.PartnerForm.EndDateActiveDate.value;
        var endmonth = document.PartnerForm.EndDateActiveMonth.value;
        var endyear = document.PartnerForm.EndDateActiveYear.value;

        var startdate = new Date(startyear,startmonth,startday);
        var enddate = new Date(endyear,endmonth,endday);

        var startTime = startdate.getTime();
        var endTime = enddate.getTime();

        if (startTime > endTime)
        {
            alert( msg_startAfterEnd );
            return false;
        }
    
    }
// END NON-TRANSLATABLE
