/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2005, 2008 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE
function addToListBox(comboBox, listBox)
{
    // adds selected item in comboBox to listBox (if it doesn't exist yet)
    i = comboBox.selectedIndex;
    if ( i == -1 || i == 0)
        return;
    // see if it is already in the list
    for (j = 0; j < listBox.options.length; j++)
    {
        if ( listBox.options[j].value == comboBox.options[i].value )
            return;	// already got it
    }
    // else add the selected item to the DistiList
    j = listBox.options.length;
    listBox.options[j] = new Option( comboBox.options[i].text,
                                     comboBox[i].value,
                                     false,
                                     false);
}


function distributorsChangeHandler(e)
{
    var comboBox = document.PartnerForm.PartnerDistributorsList_Source;
    var listBox = document.PartnerForm.PartnerDistributorsList_PartnerDistributors_DistributorName;
    addToListBox(comboBox, listBox);
}


function deleteItem(listBox)
{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_selectEntry = "Select an entry in the listbox.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    var index = listBox.selectedIndex
    var length = listBox.length
    if ( index != -1)
    {
         for(var i=0;i<length;++i)
         {
         index = listBox.selectedIndex;
         if(index != -1)
            listBox.options[index] = null;
        }
    }
    else
    {
        alert(msg_selectEntry )
    }
}

function deleteSelectedFromList(listBox)
{
    // delete selected items in the PhoneList
    while ((i = listBox.selectedIndex) > -1 )
    {
        listBox.options[i] = null;
    }
}

function removeSpacerFromList(listBox)
{
    if ( listBox.options.length > 0 )
    {
        if ( listBox.options[0].text == "------------------------" )
        listBox.options[0] = null;
    }
}

function initInfoPage(f)
{
    if ( f.PartnerDistributorsList_Source)
    {
        f.PartnerDistributorsList_Source.onchange = distributorsChangeHandler;
    }
    if ( f.PartnerDistributorsList_PartnerDistributors_DistributorName)
    {
        removeSpacerFromList(f.PartnerDistributorsList_PartnerDistributors_DistributorName);
    }
    if ( document.PartnerForm.PartnerName)
    {
        document.PartnerForm.PartnerName.focus();
    }
}


function buildListValues( listBox, hiddenList)
{
    i = listBox.options.length;
    var list = "";
    var first = true;
    for( j = 0; j < i; j++)
    {
        if ( !first )
        {
            list = list + "," + listBox.options[j].value;
        }
        else
        {
            first = false;
            list = listBox.options[j].value;
        }
        listBox.options[j].selected=false;
    }
    hiddenList.value = list;
}

function setRealListValues()
{
    var listBox = document.PartnerForm.PartnerDistributorsList_PartnerDistributors_DistributorName;
    var hiddenList =document.PartnerForm.Real__DistiList;
    buildListValues(listBox, hiddenList);
}

function validateMandatoryFields()
{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_enterName = "Please enter profile name.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    if ( document.PartnerForm.PartnerName)
    {
        if ( isNewlyNullOrTrimmedEmpty(document.OriginalFieldValues.PartnerName,
                                       document.PartnerForm.PartnerName)
             == true )
        {
            alert(msg_enterName );
            document.PartnerForm.PartnerName.focus();
            return false;
        }
        return true;
    }
}
function clickInfoTab(primaryTab, secondaryTab, next, duplicateOrDelete)
{
    if (validateMandatoryFields() == false)
    {
        return;
    }
    if ( document.PartnerForm._Tab.value != primaryTab ||
         document.PartnerForm._SubTab.value != secondaryTab )
    {
       document.PartnerForm._CurrentIndex.value = "0";
    }
    document.PartnerForm._Tab.value = primaryTab;
    if ( secondaryTab != null )
    {
        document.PartnerForm._SubTab.value = secondaryTab;
    }
    if ( next != null )
    {
        document.PartnerForm._next.value = next;
    }
    setRealListValues();
    document.PartnerForm.submit();
}
function flip()
{
    if (document.images)
    {
        if (document.PartnerForm.DistiAccess.value == "0" )
        {
            document.PartnerForm.DistiAccess.value = "1";
            document.PartnerForm.Box.src = '../htdocs/shared_images/checkedBox.gif';
        }
        else
        {
            document.PartnerForm.DistiAccess.value = "0";
            document.PartnerForm.Box.src = '../htdocs/shared_images/checkbox.gif';
        }
    }
}
// END NON-TRANSLATABLE
