/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2005, 2008 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
// NLS_CHARSET=UTF-8
// START NON-TRANSLATABLE

// trims preceeding and trailing whitespaces
function trimString(strText) 
{	
    // this will get rid of leading spaces 
    while (strText.substring(0,1) == ' ')
    {
        strText = strText.substring(1, strText.length);
    }
    // this will get rid of trailing spaces 
    while (strText.substring(strText.length-1,strText.length) == ' ')
    {
        strText = strText.substring(0, strText.length-1);
    }
    return strText;
} 



function checkEmail(emailString, name)
{
    if(emailString == null || emailString.length == 0)
    {
        return true;
    }

    // Assume it is valid for now
    var isValid = 1;
    // If it doesn't have an "@" in it, it's not valid
    if (emailString.indexOf("@") == -1) {isValid = 0;}
    // If it doesn't have a "." in it, it's not valid
    if (emailString.indexOf(".") == -1) {isValid = 0;}
    // If everything is okay, submit the form
    if(isValid != 1)
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_requireValidField = "Please enter a valid " + name + ".";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        alert(msg_requireValidField );
	    return false;
    }
}

function checkDecimal(toCheck, name)
{
    var noDecimals = 0;
    if(toCheck == null || toCheck.length == 0)
	    return true;
    for ( j = 0; j < toCheck.length; j++)
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_requireValidField = "Please enter a valid decimal value for " + name + ".";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        if ((toCheck.substring(j,j+1) != "0") &&
            (toCheck.substring(j,j+1) != "1") &&
            (toCheck.substring(j,j+1) != "2") &&
            (toCheck.substring(j,j+1) != "3") &&
            (toCheck.substring(j,j+1) != "4") &&
            (toCheck.substring(j,j+1) != "5") &&
            (toCheck.substring(j,j+1) != "6") &&
            (toCheck.substring(j,j+1) != "7") &&
            (toCheck.substring(j,j+1) != "8") &&
            (toCheck.substring(j,j+1) != "9") &&
            (toCheck.substring(j,j+1) != "."))
        {
            alert(msg_requireValidField );
		    return false;
        }
        else
        {
            if ( toCheck.substring(j,j+1) == ".")
            {
                noDecimals++;
                if ( noDecimals > 1)
                {
                    alert(msg_requireValidField );
		            return false;
                }
            }
        }
    }
}

function checkInteger(input, name)
{
    if(input == null || input.length == 0)
    	return true;
    for (var i = 0; i < input.length; i++)
	{
	    isNumber = 0;
	    for (var j=0; j<10; j++) if ("" + j == input.charAt(i)) isNumber = 1;
	    if (isNumber == 0)
		{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
            var msg_requireValidField = "Please enter a valid number for " + name + ".";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
            alert(msg_requireValidField );
		    return false;
		}
	}
}




function validateStatusChangeReason(f)
{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_requireReason = "You must enter a reason when changing the status of a profile";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    if ( f.Partner_PartnerStatusCode)
    {
        var selIdx = f.Partner_PartnerStatusCode.selectedIndex;
        if ( selIdx != -1)
        {
            var currentStatus = f.Partner_PartnerStatusCode.options[selIdx].value;
            if ( currentStatus && f.OriginalPartnerStatus && currentStatus != f.OriginalPartnerStatus.value)
            {            
                f.Partner_StatusChangeReason.value = trimString(f.Partner_StatusChangeReason.value);
                var reason = f.Partner_StatusChangeReason.value;
                if ( reason == "")
                {
                    alert(msg_requireReason);
                    return false;
                }
            }
        }
    }
}

function validateCreditLimitChangeReason(f)
{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_requireReason = "You must enter a reason when changing the credit limit or currency of a profile";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    var changedCreditProperties = false;
    if ( f.Partner_CreditLimitCurrencyCode)
    {
        var selIdx = f.Partner_CreditLimitCurrencyCode.selectedIndex;
        if ( selIdx != -1)
        {
            var currentCurrency = f.Partner_CreditLimitCurrencyCode.options[selIdx].value;             
            if ( currentCurrency && f.OriginalCreditLimitCurrency && trimString(f.OriginalCreditLimitCurrency.value) != "" && currentCurrency != trimString(f.OriginalCreditLimitCurrency.value))
            {
                changedCreditProperties = true;
            }
        }
    }    
    if ( f.Partner_CreditLimit && f.OriginalCreditLimit && f.Partner_CreditLimit.value != f.OriginalCreditLimit.value)
    {
        changedCreditProperties = true;
    }    
    if (changedCreditProperties)
    {
        f.Partner_CreditLimitChangeReason.value = trimString(f.Partner_CreditLimitChangeReason.value);
        var reason = f.Partner_CreditLimitChangeReason.value;
        if ( reason == "")
        {
            alert(msg_requireReason);
            return false;
        }
    }

}

function isInteger(aNumber)
{
	var s = new String(aNumber);
	var n = s.indexOf("e");
	if(n >= 0 && n < s.length-1)
		return false;
	n = s.indexOf("E");
	if(n >= 0 && n < s.length-1)
		return false;
	n = s.indexOf(".");
	if( n >= 0 )
		return false;
	
	// catch the trailing non-digit
	if (isNaN(aNumber))
		return false;

	// note: this function return NaN if aNumber is empty.
	var n = parseInt(aNumber);
	return !isNaN(n);
}


function validateMaxRepsOrNodesPerAccount(f)
{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_repCountMustBePositive = "The Maximum number of Reps that an account can be assigned to has to be a positive number";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    if (f.Partner_MaxRepsOrNodesPerAccount)
    {
        f.Partner_MaxRepsOrNodesPerAccount.value = trimString(f.Partner_MaxRepsOrNodesPerAccount.value);
        if (f.Partner_MaxRepsOrNodesPerAccount.value != "")
        {
            var isInt = isInteger(f.Partner_MaxRepsOrNodesPerAccount.value); 
            if (!isInt || (isInt && f.Partner_MaxRepsOrNodesPerAccount.value < 0))
            {
                alert( msg_repCountMustBePositive );
                return false;
            }
        }
    }
    return true;
}
function validateCreditLimits(f)
{
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_requireNonemptyCreditLimit = "Credit Limit cannot be empty";
    var msg_creditLimit = "Credit Limit";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    if (f.Partner_CreditLimit)
    {
        f.Partner_CreditLimit.value = trimString(f.Partner_CreditLimit.value);
        var creditLimit = f.Partner_CreditLimit.value;
        if (creditLimit == null || creditLimit.length == 0)
        {
            alert(msg_requireNonemptyCreditLimit );
            f.Partner_CreditLimit.focus();
            return false;
        }
        if (creditLimit.search(/[^0-9\.]/) > -1)
        {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
            var msg_invalidFormatCreditLimit = "\"" + creditLimit 
                    + "\" is not a valid format for the credit limit.";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
            alert(msg_invalidFormatCreditLimit );
            f.Partner_CreditLimit.focus();
            return false;
        }
        if (checkDecimal(creditLimit, msg_creditLimit ) == false)
        {
            f.Partner_CreditLimit.focus();
		    return false;
		}
    }
    /*
    if ( f.Partner_AvailableCredit)
    {
        f.Partner_AvailableCredit.value = trimString(f.Partner_AvailableCredit.value);
        var availableCredit = f.Partner_AvailableCredit.value;
        if(availableCredit.search(/[^0-9\.]/) > -1)
        {
            alert("\"" + availableCredit + "\" is not a valid format for the available credit.  Please use only digits and a single decimal point.");
            f.Partner_AvailableCredit.focus();
            return false;
        }
    }
    */
}
function checkInput(f)
{
    
    if(f._Tab.value == "Info")
    {
        if(checkInput3(f.PartnerName, "Profile Name") == false)
            return false;
        /* The checks below are only valid during Partner Creation*/
        if(checkInput3(f.BusinessID, "Organization ID") == false)
        {
            f.BusinessID.focus();
            return false;
        }
        if(checkInput3(f.Address_Address1, "Address Line 1") == false)
        {
            f.Address_Address1.focus();
            return false;
        }
        if(checkInput3(f.Address_City, "City") == false)
        {
            f.Address_City.focus();
            return false;
        }
        if (document.validateCheckoutOptions && document.validateCheckoutOptions() == false)
        {
            return false;
        }
        if (window.validateFacade && validateFacade() == false)
        {
            return false;
        }
        if ( validateCreditLimits(f) == false)
        {
            return false;
        }
        if (validateCreditLimitChangeReason(f) == false)
        {
            return false;
        }
        if ( validateStatusChangeReason(f) == false)
        {
            return false;
        }        
        if ( validateMaxRepsOrNodesPerAccount(f) == false)
        {
            return false;
        }        
                            
    }

    if(f._Tab.value == "Address")
    {
        if(checkInput3(f.Address_Address1, "Address Line 1") == false)
        {
            f.Address_Address1.focus();
            return false;
        }
        if(checkInput3(f.Address_City, "City") == false)
        {
            f.Address_City.focus();
            return false;
        }            
    }

// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
    var msg_OrganizationID = "Organization ID";
    var msg_numEmployees = "Total Number of Employees";
    var msg_nextFYRevenue = "Next FY Revenue";
    var msg_currentFYRevenue = "Current FY Revenue";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
    if(f._Tab.value == "Detail")
	{
		if(checkInput3(f.BusinessID, msg_OrganizationID ) == false)
		    return false;

		if(f.NumEmployees != null)
			if(checkInteger(f.NumEmployees.value, msg_numEmployees ) == false)
		    		return false;

		if(f.PotRevNextFy != null)
			if(checkDecimal(f.PotRevNextFy.value, msg_nextFYRevenue ) == false)
			    return false;

   		if(f.PotRevCurrFy != null)
			if(checkDecimal(f.PotRevCurrFy.value, msg_currentFYRevenue ) == false)
		    return false;
	}

    if(f._Tab.value == "Business")
    {
        if ( (f.ValidateBusinessTab != null) &&
             (f.ValidateBusinessTab.value == "true") )
        {
            if ( (this.checkContractsNotes != null) &&
                 (this.checkContractsNotes() == false) )
            {
                return false;
            }

            if( (this.validateMandatoryFields != null) &&
                (this.validateMandatoryFields() == false) )
            {
                return false;
            }
            
            if( (this.checkInput != null) &&
                (this.checkBusinessTabInput() == false) )
            {
                return false;
            }
    
            if( (this.verifyDateFields != null) &&
                (this.verifyDateFields() == false) )
            {
                return false;
            }

        }
    }

    if(f._Tab.value == "Commerce")
    {        
	    if( (this.validate != null) &&
	        (this.validate() == false) )
	    {
	        return false;
	    }
    }
}

function checkInput2(l, name)
{
    var trim = /[^\s\t]+/
    var m=l.match(trim)

    if (m == null)
    {
// END NON-TRANSLATABLE
// START QUOTE TRANSLATABLE
        var msg_requireName = "Please enter " + name + ".";
// END QUOTE TRANSLATABLE
// START NON-TRANSLATABLE
        alert(msg_requireName );
        return false;
    }
}

function checkInput3(l, name)
{
    if(l != null)
        return checkInput2(l.value,name);
}

function savePartner(redirectTo)
{    
    if(document.PartnerForm._Tab.value == "Pricelists")
    {
        partnerPriceListPost();
        return;
    }    
    if(checkInput(document.PartnerForm) == false)
    {
        return;
    }
    if ( redirectTo != null )
    {
        document.PartnerForm.target = "";        
        document.PartnerForm.FrameSection.value = null;
    }

    if ( redirectTo=="LIST" )
        document.PartnerForm._ReturnToList.value = "true";
    else if ( redirectTo=="USERS" )
        document.PartnerForm._GoToUsers.value = "true";

    document.PartnerForm._SavePage.value = "true";
    if (this.setRealListValues)
    {        
         setRealListValues();
    }
    if (typeof isCreatingRootStorefront != 'undefined')
    {
        if (isCreatingRootStorefront)
        {
            showCreateMessage();
        }
    }
    document.PartnerForm.submit();

    setTimeout('document.PartnerForm.target = ""', 100);
    setTimeout('document.PartnerForm.FrameSection.value = "Data"', 100);
    setTimeout('document.PartnerForm._GoToUsers.value = "false"', 100);
    setTimeout('document.PartnerForm._ReturnToList.value = "false"', 100);
    setTimeout('document.PartnerForm._SavePage.value = "false"', 100);
}
function el(id)
{
    return document.getElementById(id)
}

function captureStorefrontEvents()
{
    el('modal').style.visibility = 'visible';
    el('modal').style.display = 'block';
    el('modal').style.width = el('body').offsetWidth;
    //el('modal').style.height = el('body').clientHeight;//el('body').offsetHeight;
    //alert(el('body').offsetHeight + ' ' + el('body').clientHeight + ' ' + document.body.offsetHeight + " " + document.body.clientHeight + " " + + document.body.scrollHeight + " " + document.clientHeight);
    //el('modal').style.height = el('body').offsetHeight;
    el('modal').style.height = document.body.scrollHeight;
    el('modal').style.left = el('body').offsetLeft;
    el('modal').style.top = el('body').offsetTop;
    //alert(el('body').offsetHeight + " " + el('body').offsetWidth + " " + el('body').offsetTop + " " + el('body').offsetLeft);
    el('modal').onmousedown = modalclick;
}

function modalclick(e)
{
    if (!e){e = window.event;}
    if (e)
    {
        e.cancelBubble = true;
        if (e.stopPropagation)
        {
            e.stopPropagation();
        }
    }
}

function closeModal()
{
    el('modal').style.visibility = 'hidden';
    el('modal').style.display = 'none';
}

function showCreateMessage()
{
    el('CreatingStorefrontMsg').style.visibility = 'visible';
    el('CreatingStorefrontMsg').style.display = 'block';    
    var msg = el('CreatingStorefrontMsg');
    msg.style.left = el('body').offsetWidth/2 - msg.offsetWidth/2;
    msg.style.top = el('body').offsetHeight/2 - msg.offsetHeight/2;
    msg.style.zIndex = 10000;    
    captureStorefrontEvents();                
}
// END NON-TRANSLATABLE
