/*
 * 
 * Licensed Materials - Property of IBM 
 *
 * IBM Sterling Selling and Fullfillment Suite 9.1 
 *
 * (c) Copyright IBM Corp. 2002, 2008 All Rights Reserved. 
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted
 * by GSA ADP Schedule Contract with IBM Corp. 
 */
/* $Id: PartnerUtil.js,v 1.4 2011/02/23 22:34:51 jsandoe Exp $
 */

    // This function returns true if the given string is empty after being
    // trimmed
    function isNullOrTrimmedEmpty(field)
    {
        var trim = /[^\s\t]+/;
        var mutated = null;

        if (field == null)
        {
            return true;
        } 

        mutated = field.value.match(trim);

        if (mutated == null)
        {
            return true;
        }

        return false;
    }

    // This function returns true if newField is null or empty when origField
    // was not; false otherwise.  It can be used to check that mandatory fields
    // that once had data are not subsequently cleared (which will cause errors
    // when the value is set in the BizObj).
    function isNewlyNullOrTrimmedEmpty(origField, newField)
    {
        // If the original field was null/empty, return false immediately.
        if (isNullOrTrimmedEmpty(origField) == true)
        {
            return false;
        } 

        // Original field had a value.  Return true if the new one doesn't.
        if (isNullOrTrimmedEmpty(newField) == true)
        {
            return true;
        }

        // Nwe field has value too.  Return false.
        return false;
    }

